window.addEventListener("load", function() {
  Scheme.load_main("presentation.wasm", {
    reflect_wasm_dir: "hoot",
    user_imports: {
      document: {
        get: () => document,
        body: () => document.body,
        getElementById: Document.prototype.getElementById.bind(document),
        createElement: Document.prototype.createElement.bind(document),
        createTextNode: Document.prototype.createTextNode.bind(document),
        createTreeWalker: Document.prototype.createTreeWalker.bind(document)
      },
      element: {
        value: (elem) => elem.value,
        setValue: (elem, value) => elem.value = value,
        checked: (elem) => elem.checked,
        setChecked: (elem, checked) => elem.checked = (checked == 1),
        setAttribute: (elem, name, value) => elem.setAttribute(name, value),
        removeAttribute: (elem, name) => elem.removeAttribute(name),
        appendChild: (parent, child) => parent.appendChild(child),
        remove: (elem) => elem.remove(),
        replaceWith: (oldElem, newElem) => oldElem.replaceWith(newElem),
        addEventListener: (elem, name, f) => elem.addEventListener(name, f),
        removeEventListener: (elem, name, f) => elem.removeEventListener(name, f)
      },
      event: {
        target: (event) => event.target,
        keyboardKey: (event) => event.key
      },
      localStorage: {
        getItem: (key) => localStorage.getItem(key) || "#f",
        setItem: (key, value) => localStorage.setItem(key, value)
      },
      treeWalker: {
        currentNode: (walker) => walker.currentNode,
        setCurrentNode: (walker, node) => walker.currentNode = node,
        nextNode: (walker) => walker.nextNode(),
        firstChild: (walker) => walker.firstChild(),
        nextSibling: (walker) => walker.nextSibling()
      }
    }
  });
});
